<?php

use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Cashbene\GatewayPrestashop\Rest\CashbeneAbstractRestController;

class CashbenePaymentGatewayIntegrationModuleFrontController extends CashbeneAbstractRestController
{
    const GET_ACTIONS = ['getEnvironment', 'getPayuPosId'];

    protected function processGetRequest(string $action, Request $request)
    {
        switch ($action) {
            case 'getEnvironment':
                return $this->getEnvironment($request);
            case 'getPayuPosId':
                return $this->getPayuPosId($request);
        }
    }

    /**
     * @return JsonResponse
     * @see Configuration::getEnvironment()
     */
    public function getEnvironment()
    {
        return $this->success(['environment' => self::$cashbeneGateway->configuration->getEnvironment()]);
    }

    /**
     * @return JsonResponse
     */
    public function getPayuPosId() {
        $environment = self::$cashbeneGateway->configuration->getEnvironment();
        return $this->success(['pos_id' => self::$cashbeneGateway->configuration->getPayuPosId($environment)]);
    }

    protected function processPostRequest(string $action, Request $request)
    {
        // TODO: Implement processPostRequest() method.
    }

    protected function processPutRequest(string $action, Request $request)
    {
        // TODO: Implement processPutRequest() method.
    }

    protected function processDeleteRequest(string $action, Request $request)
    {
        // TODO: Implement processDeleteRequest() method.
    }

}
