<?php

namespace Cashbene\GatewayPrestashop\Service;

use Db;

/**
 * https://belvg.com/blog/how-to-create-shipping-module-for-prestashop.html
 */
class InpostIntegrationService {

    const TABLE_NAME = 'cashbene_order_shipping';

    public static function createCashbeneTable() {
        Db::getInstance()->execute(
            'CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . self::TABLE_NAME . '` (
            `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
            `id_order` INT( 11 ) UNSIGNED NOT NULL,
            `value` varchar(255) NULL,
            PRIMARY KEY (`id`)
            ) ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8'
        );
    }

    public static function dropCashbeneTable() {
        Db::getInstance()->execute(
            'DROP TABLE IF EXISTS `' . _DB_PREFIX_ . self::TABLE_NAME . '`'
        );
    }

    public static function addOrderCashbeneShipping($orderId, $value) {
        $insertData = [
            'id_order'  => $orderId,
            'value'  => $value
        ];
        if (self::selectOrderCashbeneShipping($orderId)) {
            Db::getInstance()->update( self::TABLE_NAME, $insertData);
        } else {
            Db::getInstance()->insert( self::TABLE_NAME, $insertData);
        }
    }

    public static function selectOrderCashbeneShipping($id) {
        $shipping =  Db::getInstance()->getRow(
            'SELECT * FROM `' . _DB_PREFIX_ . self::TABLE_NAME . '`
            WHERE `id_order` = '.$id
        );

        return $shipping ? $shipping['value'] : null;
    }

}
