<?php

namespace Cashbene\GatewayPrestashop\Service;

use Cashbene\Core\Utils\CredentialsSession;
use Cashbene\GatewayPrestashop\Utils\Shop as ShopUtils;
use Cashbene\Core\Dto\Shop\Product;

class ProductService {


    /**
     * @param array|null $productArray
     * @return Product
     * @throws \PrestaShopDatabaseException
     * @throws \PrestaShopException
     * @throws \Symfony\Component\Serializer\Exception\ExceptionInterface
     */
    public static function getProduct(?array $productArray)
    {
        $productId = (int) $productArray['id_product'];
        $variationId = (int) $productArray['id_product_attribute'];
        $product = ShopUtils::getProduct(ShopUtils::getPsProduct($productId, $productArray['cart_quantity']), $variationId);
        $product = ShopUtils::setProductTotalPrice($product, $productArray);
        $product = ShopUtils::setProductDisplayPrice($product, $productArray);

        return $product;
    }

    public static function setProductPrices(Product $product)
    {
        $cart = CheckoutService::createNewCart([$product], null, true);

        $product->totalPrice = clone $product->unitPrice;
        $product->displayPrice = clone $product->unitPrice;
        $product->totalPrice->amount = $cart->getOrderTotal((bool) \Configuration::get('PS_TAX'), \Cart::ONLY_PRODUCTS);
        $product->displayPrice->amount = $cart->getOrderTotal((bool) \Configuration::get('PS_TAX'), \Cart::ONLY_PRODUCTS);

        return $product;
    }
}
