<?php

namespace Cashbene\GatewayPrestashop\Translations;

class OrderStatesTranslations
{
    const STANDARD_ISO_CODE = 'en';
    const PS_CHECKOUT_STATE_WAITING_CASHBENE_PAYMENT = [
        'en' => 'Waiting for Cashbene payment',
        'fr' => 'En attente de paiement par Cashbene',
        'es' => 'Esperando el pago con Cashbene',
        'it' => 'In attesa di pagamento con Cashbene',
        'nl' => 'Wachten op Cashbene-betaling',
        'de' => 'Warten auf Cashbene-Zahlung',
        'pl' => 'Oczekiwanie na płatność Cashbene',
    ];

    /**
     * Get the States Translations for the table order_state_lang
     *
     * @return array translation list
     */
    public function getTranslations($isoCode)
    {
        $isoCode = $this->confirmIsoCode($isoCode);

        return [
            'PS_CHECKOUT_STATE_WAITING_CASHBENE_PAYMENT' => self::PS_CHECKOUT_STATE_WAITING_CASHBENE_PAYMENT[$isoCode],
        ];
    }

    /**
     * Return an ISO which can get a result in the translations arrays
     *
     * @param string $isoCode
     *
     * @return string
     */
    private function confirmIsoCode($isoCode)
    {
        if (!array_key_exists($isoCode, self::PS_CHECKOUT_STATE_WAITING_CASHBENE_PAYMENT)) {
            return self::STANDARD_ISO_CODE;
        }

        return (string) $isoCode;
    }
}
